#
# PST lib Output - special output class
# 
# (c) 2002  Tomas Valla   <valla@atrey.karlin.mff.cuni.cz>
# 
# This software may be used and distributed under the terms
# of the GNU General Public License. See COPYING for details.
#

package Output;
use OM;
@ISA = qw(OM);
use strict;

sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $self = OM->new;

	$self->name("Output");
	return bless($self,$class);
}

sub run {
	my $self = shift;
	my $bb = $self->{FILE_HANDLER}->{GLOBALS};
	my $w = $self->{PAGE_WIDTH}{1};   # this is bad... 
	my $h = $self->{PAGE_HEIGHT}{1};
	for (my $i=2; $i <= $self->{NUM_PAGES}; $i++) {
		$w = $self->{PAGE_WIDTH}{$i} if $self->{PAGE_WIDTH}{$i} > $w;
		$h = $self->{PAGE_HEIGHT}{$i} if $self->{PAGE_HEIGHT}{$i} > $h;
	}

	defined $w or $w = 0;
	defined $h or $h = 0;
	$w = int $w;
	$h = int $h;


	$bb->{"BoundingBox:"} =    # store the right boundingbox
	  "0 0 $w $h";
	$bb->{"Pages:"} = $self->{NUM_PAGES};  # the final page number
	$self->previous->run;

	# now write all my pages
	for my $i (1..$self->{NUM_PAGES}) {
		print "[$i" if $self->{VERBOSE};
		$self->write_page($i);
		print "] " if $self->{VERBOSE};
	}
}


sub write_page {
	my $self = shift;
	my $page = shift;
	my $f = $self->{OUTPUT};

	$self->{FILE_HANDLER}->write_page_header($page);  # first the header...
	$self->previous->write_page($page);  # ... and previous will do the rest
}


1;  # no init...

