#
# unused module
#
# options:
# h|horizontal = <int>        horiz. displacement
# v|vertical  =<int>          vert. disp.


package Pan;
use OM;
use sizes;
@ISA = qw(OM);
use strict;



sub new {
	my $proto = shift;
	my $class = ref($proto) || $proto;
	my $self = OM->new;

	$self->name("Pan");
	$self->{H_DISP} = 0;
	$self->{V_DISP} = 0;

	return bless($self,$class);
}

sub parse_options {
	my $self = shift;
	my $str = "";

	while (my $s = shift) { $str .= $s }
	foreach  (split /;/, $str) {
		if (/^\s*(h|horizontal)\s*\=\s*(-?\w+)\s*$/) {
			my $u = unit_size($2);
			$self->die($u) if $u =~ /^ERROR/;
			$self->{H_DISP} = $u;
		} elsif (/^\s*(v|vertical)\s*\=\s*(-?\w+)\s*$/) {
			my $u = unit_size($2);
			$self->die($u) if $u =~ /^ERROR/;
			$self->{V_DISP} = $u;
		} else {
			$self->die("bad option ($_)\n");
		}
	}
}

sub write_page_prolog {
	my $self = shift;
	my $page = shift;
	my $f = $self->{OUTPUT};

	print $f
		"save\n",
		$self->{H_DISP}," ",$self->{V_DISP}," translate\n";
}

sub write_page_epilog {
	my $self = shift;
	my $f = $self->{OUTPUT};

	print $f "restore\n";
}

1;  # no init
